public class QuickSelect {

   static void swap(int[] a, int i, int j) {
      int tmp = a[i];
      a[i] = a[j];
      a[j] = tmp;
   }

   static int minimum(int[] a) {
      int n = a.length;      
      if (n > 0) {
         int min = a[0];
         int index = 0;
         for (int j=1; j<n; j++) {
            if (a[j] < min) {
               index = j;
               min = a[j];
            }
         }
         return index;
      } else {
         return -1;
      }
   }


   static int pivot(int[] a, int l, int r) {
      throw new RuntimeException("Implement me");
   }

   static void quickSelect(int[] a, int x) {
      if (x < 0 || x >= a.length) {
         throw new RuntimeException("no x-th element");
      }
      swap(a, 0, minimum(a));
      if (x > 0) {
         quickSelect(a, 1, a.length-1, x);
      }
   }

   static void quickSelect(int[] a, int l, int r, int x) {
      while (l < r) {
         int p = pivot(a,l,r); 
         int v = a[p]; // Partition: von hier bis ...
         int i = l - 1; 
         int j = r;
         swap(a,p,r);
         while (true) {
            do i++; while (a[i] < v); 
            do j--; while (a[j] > v); 
            if (i >= j) {
               break;
            }
            swap(a,i,j); 
         }
         swap(a,r,i); // ... hier gleich zu quickSort
         if (i > x) {
            r = i-1;
         } else if (i == x) {
            return;
         } else {
            l = i+1;
         }
      }
   }
   
   static void quickSortMedian(int[] a) {
      if (a.length > 0) swap(a, 0, minimum(a));
      quickSortMedian(a, 1, a.length - 1);
   }
   
   static void quickSortMedian(int[] a, int l, int r) {
      if (l < r) {
         int m = (l+1)/2 + r/2;
         quickSelect(a, l, r, m);
         quickSortMedian(a,l,m-1);
         quickSortMedian(a,m+1,r);         
      }
   }

}
